package com.muyu.loadcenter.common;

import com.muyu.domain.model.MqttServerModel;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.extern.log4j.Log4j2;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * @ClassName AccessPool
 * @Description 描述
 * @Author YunFei.Du
 * @Date 2024/5/27 22:39
 */
@Data
@NoArgsConstructor
@Log4j2
public class AccessPool {
    private static Integer sequence = 0;

    private static Map<String, MqttServerModel > accessPools = new HashMap<> ();

    public static void initAccessPools(List<MqttServerModel> mqttServerModels){
        accessPools = mqttServerModels.stream().collect( Collectors.toMap(MqttServerModel::getBroker, Function.identity()));
    }

    public static void addAccessPool(MqttServerModel mqttServerModel){
        accessPools.put(mqttServerModel.getBroker(),mqttServerModel);
    }

    public static void lookAccessPools(){
        accessPools.forEach((k,v)->{
            log.info("key:"+k+" value:"+v.toString());
        });
    }

    public static MqttServerModel getMqttServerModel(){
        if (sequence == accessPools.size()){
            sequence = 0;
        }
        Set<String> strings = accessPools.keySet();
        return accessPools.get(strings.toArray()[sequence++]);
    }
}
