//package com.zhiLian.config;
//
//
//import com.alibaba.fastjson2.JSON;
//import com.alibaba.fastjson2.JSONArray;
//import com.alibaba.fastjson2.JSONObject;
//import com.aliyun.ecs20140526.Client;
//import com.zhiLian.common.ConnectWeight;
//import com.zhiLian.service.impl.LoadBalanceServiceImpl;
//import com.zhiLian.utils.ECSTool;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.boot.ApplicationArguments;
//import org.springframework.boot.ApplicationRunner;
//import org.springframework.data.redis.core.RedisTemplate;
//import org.springframework.http.*;
//import org.springframework.stereotype.Component;
//import org.springframework.web.client.RestTemplate;
//
//import java.math.BigDecimal;
//import java.math.RoundingMode;
//import java.util.*;
//
//
///**
// * 初始化连接权重
// *
// * @author YouChe·He
// * @ClassName: InitConnectWeight
// * @Description: 初始化连接权重
// * @CreateTime: 2024/5/27 21:31
// */
//@Component
//@Slf4j
//public class InitConnectWeight implements ApplicationRunner {
//
//    @Autowired
//    private RedisTemplate<String, String> redisTemplate;
//
//    @Autowired
//    private RestTemplate restTemplate;
//    @Autowired
//    private LoadBalanceServiceImpl loadBalanceServiceimpl;
//
//    @Override
//    public void run(ApplicationArguments args) throws Exception {
//
//        ArrayList<ConnectWeight> connectWeightList = new ArrayList<>();
//
//
//        Client client = null;
//        //获取阿里云客户端
//        try {
//            client = ECSTool.createClient();
//        } catch (Exception e) {
//            throw new RuntimeException(e);
//        }
//        //获取所有实例
//        List< String > ipList = ECSTool.FindInstance ( "cn-zhangjiakou" );
//
//
//        //http://fluxmq.muyu.icu/public/login
//
//        //遍历所有ip,获取每一个服务的连接数
//        for (String ip : ipList) {
//            String url = "http://" + ip + ":8080/public/login";
//            Map<String, Object> request = new HashMap<>();
//            request.put("username", "fluxmq");
//            request.put("password", "fluxmq");
//            HttpHeaders httpHeaders = new HttpHeaders();
//            httpHeaders.setContentType(MediaType.APPLICATION_JSON);
//            HttpEntity<Map<String, Object>> r = new HttpEntity<Map<String, Object>>(request, httpHeaders);
//            String result = restTemplate.postForObject(url, r, String.class);
//
//
//            //http://fluxmq.muyu.icu/public/cluster
//
//            int nextInt = new Random().nextInt(1000);
//            String getInfoUrl = "http://" + ip + ":8080/public/cluster?random=" + nextInt;
//
//            HttpHeaders httpHeadersGetInfo = new HttpHeaders();
//            httpHeadersGetInfo.setContentType(MediaType.APPLICATION_JSON);
//            httpHeadersGetInfo.setAccept(Collections.singletonList(MediaType.APPLICATION_JSON));
//            httpHeadersGetInfo.set("Cookie", result);
//            HttpEntity getInfoRequest = new HttpEntity(httpHeadersGetInfo);
//            ResponseEntity<String> responseInfo = restTemplate.exchange(getInfoUrl, HttpMethod.GET, getInfoRequest, String.class, 1);
//
//            log.error("响应是:{}", responseInfo.getBody());
//
//            JSONArray jsonArray = JSON.parseArray(responseInfo.getBody());
//            if (jsonArray.size() > 0) {
//
//                JSONObject jsonObject = jsonArray.getJSONObject(0);
//                Integer connectSize = Integer.valueOf(jsonObject.getJSONObject("mqttInfo").getString("connectSize"));
//                connectWeightList.add(new ConnectWeight(ip,100-connectSize));
//                log.error("链接数量:{}", connectSize);
//            } else {
//                log.error("得到的相应数据为null");
//            }
//        }
//        Integer sum =0;
//        for (ConnectWeight connectWeight : connectWeightList) {
//            sum = sum + connectWeight.getWeightValue();
//        }
//
//        int max = 0;
//        for (ConnectWeight connectWeight : connectWeightList) {
//            log.error("权重值:{}",connectWeight.getWeightValue());
//            Integer result = BigDecimal.valueOf(connectWeight.getWeightValue() * 100).divide(BigDecimal.valueOf(sum), 0, RoundingMode.DOWN).intValue();
//            if (result > max){
//                max = result;
//            }
//            connectWeight.setWeightValue(result);
//            log.error("100次轮询次数:{}",result);
//        }
//
//        ArrayList<String> weightIpList = new ArrayList<>();
//
//        //轮询出现次数
//        for (int i = 0; i <= max; i++) {
//            for (ConnectWeight connectWeight : connectWeightList) {
//                if (connectWeight.getWeightValue() > i){
//                    weightIpList.add(connectWeight.getCarServerIp());
//                }else if (connectWeight.getWeightValue() == max){
//                    weightIpList.add(connectWeight.getCarServerIp());
//                }
//            }
//        }
//
//        //存入redis
//        redisTemplate.delete("ipList");
//        for (String ip : weightIpList) {
//            redisTemplate.opsForList().rightPush("ipList",ip);
//        }
//    }
//}
