package com.zhiLian.consumer;

import lombok.extern.log4j.Log4j2;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

/**
 * @ClassName ReceiveHandler
 * @Description 描述
 * @Author YunFei.Du
 * @Date 2024/5/29 20:08
 */
@Component
@Log4j2
public class ReceiveHandler {
    @Autowired
    private RedisTemplate redisTemplate;

//    test
    @RabbitListener(queues = {"ADD_LOG_AAA"})
    public void addLog(String msg) {
        log.info("接收到消息：{}", msg);
        redisTemplate.opsForList().leftPush("log", msg);
    }

    @RabbitListener(queues = {"test"})
    public void receiveSms(Message message) {
        log.info("接收到消息：{}", message);
        redisTemplate.opsForList().leftPush("log", message);
    }
}
