package com.zhiLian.service.impl;

import com.aliyun.ecs20140526.models.DescribeInstancesResponse;
import com.aliyun.ecs20140526.models.ModifySecurityGroupRuleResponse;
import com.google.gson.Gson;
import com.zhiLian.service.LoadBalanceService;
import lombok.SneakyThrows;
import lombok.extern.log4j.Log4j2;
import org.springframework.stereotype.Service;

import java.util.List;

import static com.zhiLian.utils.ECSTool.*;

/**
 * @ClassName LoadBalanceService
 * @Description 描述
 * @Author YunFei.Du
 * @Date 2024/5/28 9:25
 */
@Service
@Log4j2
public class LoadBalanceServiceImpl implements LoadBalanceService {

    @SneakyThrows
    @Override
    public void createConnect() {
            runEcsInstance("cn-zhangjiakou", "lt-8vbepqjihmawbkqcwkcm");

    }

    @Override
    public void removeConnect(String instanceId) {

        try {
            runEcsStop (instanceId);
        } catch (Exception e) {
            log.error ( "getDescribeInstances error:{}", e );
            throw new RuntimeException ( e );
        }
    }

    @SneakyThrows
    @Override
    public void stopConnect(String instanceId) {
        runEcsRemove ( instanceId );
    }

    @SneakyThrows
    @Override
    public List< String > getIpList() {
        List< String > ipList = FindInstance ( "cn-zhangjiakou" );
        return ipList;
    }
}
